var xmlDoc = System.Gadget.document.parentWindow.xmlDoc;
var nameIX      = 0;
var genereIX    = 1;
var colorIX     = 2;
var mediaUrlIX  = 3;
var webIX       = 4;
var bookmarkIX  = 5;
var notesIX     = 6;
var cityIX      = 7;
var proxyIX	= 8;
var lastGenere  = System.Gadget.Settings.read("lastGenere");
var lastStation = System.Gadget.Settings.read("lastStation");
var showMarkedOnly = System.Gadget.Settings.read("showMarkedOnly");

/* -------------------------------------------
   - Fill the Genere listbox with all generes
   -------------------------------------------*/
var generes = new Array();
function fillGenereListBox()
{
	/*-----------------------------------------------------
     	 * Clear the table of generes
     	 *-----------------------------------------------------*/
    	generes.length = 0;
    	/*-----------------------------------------------------
       	 * Loop thru all station elements and save all distinct genere names
     	 *-----------------------------------------------------*/
    	var stationsElement = xmlDoc.getElementsByTagName("station");
    	for (var i = 0; i < stationsElement.length; i++)
    	{
        	if(!genereAlreadySaved(stationsElement.item(i).attributes(genereIX).value))
            	{
            		generes.push(stationsElement.item(i).attributes(genereIX).value);
            	}
    	}
    	/*-----------------------------------------------------
     	 * Sort the table
     	 *-----------------------------------------------------*/
    	generes.sort();
    	/*-----------------------------------------------------
     	 * Clear and reload the genereDD
     	 *-----------------------------------------------------*/
    	document.getElementById("generesDD").options.length=0;
    	var optSelected = false;
    	for (i = 0; i < generes.length; i++)
    	{
        	var optn = document.createElement("OPTION");
        	optn.text = generes[i];
        	optn.value = generes[i];
        	document.getElementById("generesDD").options.add(optn);
        	if(generes[i] == lastGenere)
        	{
        	    document.getElementById("generesDD").options[i].selected=true;
        	    optSelected = true;
        	}
    	}
    	/*-----------------------------------------------------
     	 * settings
     	*-----------------------------------------------------*/
      	if(document.getElementById("generesDD").options.length > 0)
    	{
      	  if(!optSelected){document.getElementById("generesDD").options[0].selected=true;}

     	  var selectedValue = document.getElementById("generesDD").value;
    	  System.Gadget.Settings.write("lastGenere", selectedValue);
     	  lastGenere = selectedValue;
     	  System.Gadget.document.parentWindow.lastGenere = selectedValue;
    	}
    	else
    	{
    		System.Gadget.Settings.write("lastGenere", "");
    		System.Gadget.document.parentWindow.lastGenere = "";
     	  	lastGenere = "";
    	}

}
function genereAlreadySaved(genere)
{
    for (var i = 0; i < generes.length; i++)
    {
        if(generes[i] == genere)
        {
            return true;
        }
    }
    return false;
}
/***********************************************************
 * genereDD changed
 ***********************************************************/
function onchangeGenereDD()
{
    /*-----------------------------------------------------
     * Clear the table of generes
     *-----------------------------------------------------*/
    var selectedValue = document.getElementById("generesDD").value;
    System.Gadget.Settings.write("lastGenere", selectedValue);
    lastGenere = selectedValue;
    System.Gadget.document.parentWindow.lastGenere = selectedValue;

    fillStationListBox();

    getStationInfo();
}
/***********************************************************
 * select the stations for the selected genere from the
 * database and load them into the drop down menu
 ***********************************************************/
var stations = new Array();
function fillStationListBox()
{
    /*-----------------------------------------------------
     * Clear the table of generes
     *-----------------------------------------------------*/
    stations.length = 0;
    /*-----------------------------------------------------
     * Loop thru the station elements and save all
     *-----------------------------------------------------*/
    var stationsElement = xmlDoc.getElementsByTagName("station[@genere='"+lastGenere+"']");
    for (var i = 0; i < stationsElement.length; i++)
    {
     	var allAttributes = stationsElement.item(i).attributes;
        var numberOfAttributes = allAttributes.length;
        if(!document.getElementById("showMarkedBX").checked)
            stations.push(stationsElement.item(i).attributes(nameIX).value+"§"+stationsElement.item(i).attributes(colorIX).value);
            
        else if((document.getElementById("showMarkedBX").checked)&&(stationsElement.item(i).attributes(bookmarkIX).value == "true"))
            stations.push(stationsElement.item(i).attributes(nameIX).value+"§"+stationsElement.item(i).attributes(colorIX).value);
     }

    /*-----------------------------------------------------
     * Sort the tablemediaUrlIX
     *-----------------------------------------------------*/
    stations.sort();
    /*-----------------------------------------------------
     * Clear and reload the dropdown
     *-----------------------------------------------------*/
    document.getElementById("stationsDD").options.length=0;
    var optSelected = false;
    for (i = 0; i < stations.length; i++)
    {
        var stationAttr = new Array();
        stationAttr = stations[i].split("§");
        var optn = document.createElement("OPTION");

        optn.text = stationAttr[0];
        optn.value = stationAttr[0];
        optn.style.color=stationAttr[1];
        document.getElementById("stationsDD").options.add(optn);


        if(stationAttr[0] == lastStation)
        {
            document.getElementById("stationsDD").options[i].selected=true;
            optSelected = true;
        }

    }
   /*-----------------------------------------------------
     * settings
     *-----------------------------------------------------*/
    if(document.getElementById("stationsDD").options.length>0)
    {
        if(!optSelected){document.getElementById("stationsDD").options[0].selected=true;}

        var selectedValue = document.getElementById("stationsDD").value;
    	System.Gadget.Settings.write("lastStation", selectedValue);
     	lastStation = selectedValue;
     	System.Gadget.document.parentWindow.lastStation = selectedValue;
        getStationInfo();
    }
   /*-----------------------------------------------------
     * no Stations
     *-----------------------------------------------------*/
   if(document.getElementById("stationsDD").options.length==0)
   {
   	  System.Gadget.Settings.write("lastStation", "");
      lastStation = "";
      System.Gadget.document.parentWindow.lastStation = "";
   }

}
/***********************************************************
 * stationDD changed
 ***********************************************************/
function onchangeStationDD()
{
    var selectedValue = document.getElementById("stationsDD").value;
    System.Gadget.Settings.write("lastStation", selectedValue);
    lastStation = selectedValue;
    System.Gadget.document.parentWindow.lastStation = selectedValue;
    getStationInfo();
}
/***********************************************************
 * show marked only clicked
 ***********************************************************/
function onclickMarkedBX()
{
    if(document.getElementById("showMarkedBX").checked)
    {
        System.Gadget.Settings.write("showMarkedOnly", "true");
        showMarkedOnly = "true";
    }
    else
    {
        System.Gadget.Settings.write("showMarkedOnly", "false");
        showMarkedOnly = "false";
    }
    //openFlyout('menu',' ');
    fillStationListBox();
}
/***********************************************************
 * get station information
 ***********************************************************/
function getStationInfo()
{

    var stationsElement = xmlDoc.getElementsByTagName("station[@name='"+lastStation+"' && @genere='"+lastGenere+"']");
    for (var i = 0; i < stationsElement.length; i++)
    {
 	document.getElementById("stationName").value =stationsElement.item(i).attributes(nameIX).value;
 	document.getElementById("stationGenere").value =stationsElement.item(i).attributes(genereIX).value;
 	document.getElementById("stationCity").value =stationsElement.item(i).attributes(cityIX).value;
 	document.getElementById("stationUrl").value =stationsElement.item(i).attributes(webIX).value;
 	document.getElementById("stationStream").value =stationsElement.item(i).attributes(mediaUrlIX).value;

 	if(document.getElementById("wwwIcon"))
 	{
    	if(document.getElementById("stationUrl").value.substr(0,4) != "http")
    	{
    	    document.getElementById("wwwIcon").style.visibility = "hidden";  
    	} 
    	else
    	{
    	    document.getElementById("wwwIcon").style.visibility = "visible";  
    	} 
    }	
 	
 	
 	if(document.getElementById("stationStream").value)
 	{
 		if(System.Gadget.document.parentWindow.isPlaying)
 		{
 			System.Gadget.document.parentWindow.playStream();
 		}
 	}

 	var whichColor = stationsElement.item(i).attributes(colorIX).value;
 	buildColorDD(whichColor);

 	if(stationsElement.item(i).attributes(bookmarkIX).value == "true"){document.getElementById("stationBookmark").checked = true;}
 	else{document.getElementById("stationBookmark").checked = false;}

 	if(stationsElement.item(i).attributes(proxyIX).value == "true"){document.getElementById("stationProxy").checked = true;}
 	else{document.getElementById("stationProxy").checked = false;}

 	document.getElementById("stationNotes").value =stationsElement.item(i).attributes(notesIX).value;
    }
}
/*-----------------------------------------------------
 * Clear and reload the colorDD
 *-----------------------------------------------------*/
function buildColorDD(whichColor)
{

    var colorValues = new Array("black","red","green","blue","yellow","gray");
    if(document.getElementById("stationColorDD"))
    {
        for (i = 0; i < colorValues.length; i++)
        {
            var optn = document.createElement("OPTION");
            optn.text = "    ";
            optn.value = colorValues[i];
            document.getElementById("stationColorDD").options.add(optn);
            document.getElementById("stationColorDD").options[i].style.background=colorValues[i];
            if(colorValues[i] == whichColor)
            {
                document.getElementById("stationColorDD").options[i].selected=true;
            }
        }   
    }
    if(document.getElementById("stationColor"))
 	   document.getElementById("stationColor").style.background = whichColor;
}
/***********************************************************
 * save a record
 ***********************************************************/
function saveRecord()
{
    // get the form values
    var genereValue = trimAll(document.getElementById("stationGenere").value);
    var stationValue = trimAll(document.getElementById("stationName").value);
    var cityValue = trimAll(document.getElementById("stationCity").value);
    var weburlValue = trimAll(document.getElementById("stationUrl").value);
    var mediaurlValue = trimAll(document.getElementById("stationStream").value);
    var notesValue = trimAll(document.getElementById("stationNotes").value); 
    var bookmarkValue;
    if(document.getElementById("stationBookmark").checked == true){bookmarkValue = "true";}
    else{bookmarkValue = "false";}  
    var proxyValue;
    if(document.getElementById("stationProxy").checked == true){proxyValue = "true";}
    else{proxyValue = "false";}
    var colorValue = document.getElementById("stationColorDD").value;
    
    // delete old if update
    var node;
    if (System.Gadget.Settings.read("paramCache")!="new")
    {
        node = xmlDoc.selectSingleNode("//root/stations/station[@name='" + lastStation + "']");
        node.parentNode.removeChild(node);
    }  
    
    // insert the record
    node = xmlDoc.selectSingleNode("//root/stations");
    var newel=xmlDoc.createElement('station');
    var newatt;
    // ************ DO NOT CHANGE THE ATTRIBUTES ORDERS ************* 
        newatt=xmlDoc.createAttribute("name");
        newatt.value = stationValue;
        newel.setAttributeNode(newatt);

        newatt=xmlDoc.createAttribute("genere");
        newatt.value = genereValue;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("color");
        newatt.value = colorValue;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("mediaurl");
        newatt.value = mediaurlValue;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("weburl");
        newatt.value = weburlValue;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("bookmarks");   
        newatt.value = bookmarkValue;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("notes");
        newatt.value = notesValue;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("city");
        newatt.value = cityValue;
        newel.setAttributeNode(newatt);
        
        newatt=xmlDoc.createAttribute("proxy");
        newatt.value = proxyValue;
        newel.setAttributeNode(newatt);
  
        node.appendChild(newel);
      
        xmlDoc.save(System.Gadget.document.parentWindow.stationsDB);
        
        //settings 
        System.Gadget.Settings.write("lastStation", stationValue);
        System.Gadget.Settings.write("lastGenere", genereValue);  
}
/* -------------------------------------------
   - delete a station
   -------------------------------------------*/
function deleteRecord()
{
   var node = xmlDoc.selectSingleNode("//root/stations/station[@name='" + lastStation + "']");
   node.parentNode.removeChild(node);
   xmlDoc.save(System.Gadget.document.parentWindow.stationsDB);  
  
   //settings 
   System.Gadget.Settings.write("lastStation", "");
   System.Gadget.Settings.write("lastGenere", "");    
}

/* -------------------------------------------
   - check if a record already exists
   -------------------------------------------*/
function stationExists(whichStation)
{
   var node = xmlDoc.selectSingleNode("//root/stations/station[@name='" + whichStation + "']");
   if(!node)
        return false;     
   else
        return true;     
}

/* -------------------------------------------
   - Open flyouts
   -------------------------------------------*/
function openFlyout(whichFlyout,param)
{
    if(param)
        System.Gadget.Settings.write("paramCache", param);
    else 
        System.Gadget.Settings.write("paramCache", "");   
 
    System.Gadget.Flyout.file = "../flyouts/"+whichFlyout+".html";
    System.Gadget.Flyout.show = true;    
}
/***********************************************************
 * close the window
 ***********************************************************/
function closeFlyout()
{
	System.Gadget.Flyout.show = false;
}
/***********************************************************
 * trim string
 ***********************************************************/
function trimAll(sString) 
{
while (sString.substring(0,1) == ' ')
{
sString = sString.substring(1, sString.length);
}
while (sString.substring(sString.length-1, sString.length) == ' ')
{
sString = sString.substring(0,sString.length-1);
}
return sString;
}
/***********************************************************
 * reset readonly checkmarks
 ***********************************************************/
function resetChecks(objID) 
{
    if(objID.checked == true){objID.checked = false;}
    else{objID.checked = true;}   
}
/***********************************************************
 * Help
 ***********************************************************/
function showHelp()
{
	document.getElementById("helpDiv").style.visibility = "visible";
	document.getElementById("helpText").style.visibility = "visible";
	document.getElementById("helpClosebutton").style.visibility = "visible";
}
function hideHelp()
{
	document.getElementById("helpDiv").style.visibility = "hidden";
	document.getElementById("helpText").style.visibility = "hidden";
	document.getElementById("helpClosebutton").style.visibility = "hidden";
}
/***********************************************************
 * Visit the stations website
 ***********************************************************/
function browseURL()
{
    var stationsElement = xmlDoc.getElementsByTagName("station[@name='"+lastStation+"' && @genere='"+lastGenere+"']");
    for (var i = 0; i < stationsElement.length; i++)
    {
 	    var stationUrl = document.getElementById("stationUrl").value =stationsElement.item(i).attributes(webIX).value;
 	    var load = window.open(stationUrl,"SidebarRadio",'left=20,top=20,width=800,height=600,toolbar=1,resizable=1,scrollbars=1');
 	}
}